import * as _arco_design_web_vue_es__utils_types from '@arco-design/web-vue/es/_utils/types';
import * as _arco_design_web_vue_es_table_interface from '@arco-design/web-vue/es/table/interface';
import * as _arco_design_web_vue_es__components_virtual_list_v2_interface from '@arco-design/web-vue/es/_components/virtual-list-v2/interface';
import * as _arco_design_web_vue from '@arco-design/web-vue';
import { PaginationProps, TableData } from '@arco-design/web-vue';
import * as vue from 'vue';
import { Ref } from 'vue';
import { TableColumnDataPlus } from '../useColumns/index.js';
import { OperationItem } from './interface.js';

type ModifyRequiredKeys<T, K extends keyof T> = Omit<T, K> & {
    [P in K]-?: T[P];
};
type PaginationPropsPlus = ModifyRequiredKeys<PaginationProps, 'current' | 'pageSize' | 'total'>;
interface Params {
    /**
     * visible=true的dataIndex集合
     * 当多级表头的时候columnKeys 为最后一级的集合
     */
    columnKeys: string[];
}
interface TableConfig<T> {
    fetch?: (data: Params) => Promise<T>;
    columns: TableColumnDataPlus[];
    pagination?: boolean | PaginationProps;
    operationsFixed?: 'left' | 'right' | false;
    operations?: (record: TableData) => OperationItem[];
    immediate?: boolean;
}
declare function useTable<T extends Record<string, unknown>>(config: TableConfig<T[]>): {
    tableData: Ref<T[]>;
    loading: Ref<boolean>;
    loadTableData: () => Promise<void>;
    pagination: Ref<false | PaginationPropsPlus>;
    tableInstance: Ref<({
        $: vue.ComponentInternalInstance;
        $data: {};
        $props: {
            size?: "mini" | "medium" | "large" | "small" | undefined;
            scrollbar?: boolean | _arco_design_web_vue.ScrollbarProps | undefined;
            data?: TableData[] | undefined;
            loading?: boolean | Record<string, any> | undefined;
            bordered?: boolean | _arco_design_web_vue.TableBorder | undefined;
            columns?: _arco_design_web_vue.TableColumnData[] | undefined;
            hoverable?: boolean | undefined;
            pagination?: boolean | PaginationProps | undefined;
            stripe?: boolean | undefined;
            tableLayoutFixed?: boolean | undefined;
            pagePosition?: "top" | "tl" | "tr" | "bottom" | "bl" | "br" | undefined;
            indentSize?: number | undefined;
            rowKey?: string | undefined;
            showHeader?: boolean | undefined;
            spanAll?: boolean | undefined;
            filterIconAlignLeft?: boolean | undefined;
            hideExpandButtonOnEmpty?: boolean | undefined;
            columnResizable?: boolean | undefined;
            summaryText?: string | undefined;
            defaultExpandAllRows?: boolean | undefined;
            stickyHeader?: number | boolean | undefined;
            showEmptyTree?: boolean | undefined;
            readonly rowSelection?: _arco_design_web_vue.TableRowSelection | undefined;
            readonly expandable?: _arco_design_web_vue.TableExpandable | undefined;
            readonly scroll?: {
                x?: string | number | undefined;
                y?: string | number | undefined;
                minWidth?: string | number | undefined;
                maxHeight?: string | number | undefined;
            } | undefined;
            readonly virtualListProps?: _arco_design_web_vue_es__components_virtual_list_v2_interface.VirtualListProps | undefined;
            readonly spanMethod?: ((data: {
                record: TableData;
                column: _arco_design_web_vue.TableColumnData | _arco_design_web_vue_es_table_interface.TableOperationColumn;
                rowIndex: number;
                columnIndex: number;
            }) => void | {
                rowspan?: number | undefined;
                colspan?: number | undefined;
            }) | undefined;
            readonly components?: _arco_design_web_vue_es_table_interface.TableComponents | undefined;
            readonly loadMore?: ((record: TableData, done: (children?: TableData[] | undefined) => void) => void) | undefined;
            readonly rowClass?: string | any[] | Record<string, any> | ((record: TableData, rowIndex: number) => any) | undefined;
            readonly draggable?: _arco_design_web_vue.TableDraggable | undefined;
            readonly rowNumber?: boolean | Record<string, any> | undefined;
            readonly summary?: boolean | ((params: {
                columns: _arco_design_web_vue.TableColumnData[];
                data: TableData[];
            }) => TableData[]) | undefined;
            readonly summarySpanMethod?: ((data: {
                record: TableData;
                column: _arco_design_web_vue.TableColumnData | _arco_design_web_vue_es_table_interface.TableOperationColumn;
                rowIndex: number;
                columnIndex: number;
            }) => void | {
                rowspan?: number | undefined;
                colspan?: number | undefined;
            }) | undefined;
            readonly selectedKeys?: (string | number)[] | undefined;
            readonly defaultSelectedKeys?: (string | number)[] | undefined;
            readonly expandedKeys?: (string | number)[] | undefined;
            readonly defaultExpandedKeys?: (string | number)[] | undefined;
            key?: string | number | symbol | undefined;
            ref?: vue.VNodeRef | undefined;
            ref_for?: boolean | undefined;
            ref_key?: string | undefined;
            onVnodeBeforeMount?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeMounted?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeBeforeUpdate?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeUpdated?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeBeforeUnmount?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeUnmounted?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            class?: unknown;
            style?: unknown;
            onPageChange?: ((page: number) => any) | undefined;
            onPageSizeChange?: ((pageSize: number) => any) | undefined;
            onColumnResize?: ((dataIndex: string, width: number) => any) | undefined;
            onChange?: ((data: TableData[], extra: _arco_design_web_vue.TableChangeExtra, currentData: TableData[]) => any) | undefined;
            onSelect?: ((rowKeys: (string | number)[], rowKey: string | number, record: TableData) => any) | undefined;
            onExpand?: ((rowKey: string | number, record: TableData) => any) | undefined;
            "onUpdate:selectedKeys"?: ((rowKeys: (string | number)[]) => any) | undefined;
            "onUpdate:expandedKeys"?: ((rowKeys: (string | number)[]) => any) | undefined;
            onExpandedChange?: ((rowKeys: (string | number)[]) => any) | undefined;
            onSelectAll?: ((checked: boolean) => any) | undefined;
            onSelectionChange?: ((rowKeys: (string | number)[]) => any) | undefined;
            onSorterChange?: ((dataIndex: string, direction: string) => any) | undefined;
            onFilterChange?: ((dataIndex: string, filteredValues: string[]) => any) | undefined;
            onCellMouseEnter?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onCellMouseLeave?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onCellClick?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onRowClick?: ((record: TableData, ev: Event) => any) | undefined;
            onHeaderClick?: ((column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onRowDblclick?: ((record: TableData, ev: Event) => any) | undefined;
            onCellDblclick?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onRowContextmenu?: ((record: TableData, ev: Event) => any) | undefined;
            onCellContextmenu?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        };
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: vue.Slot<any> | undefined;
        }>;
        $root: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $parent: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $emit: ((event: "update:selectedKeys", rowKeys: (string | number)[]) => void) & ((event: "update:expandedKeys", rowKeys: (string | number)[]) => void) & ((event: "expand", rowKey: string | number, record: TableData) => void) & ((event: "expandedChange", rowKeys: (string | number)[]) => void) & ((event: "select", rowKeys: (string | number)[], rowKey: string | number, record: TableData) => void) & ((event: "selectAll", checked: boolean) => void) & ((event: "selectionChange", rowKeys: (string | number)[]) => void) & ((event: "sorterChange", dataIndex: string, direction: string) => void) & ((event: "filterChange", dataIndex: string, filteredValues: string[]) => void) & ((event: "pageChange", page: number) => void) & ((event: "pageSizeChange", pageSize: number) => void) & ((event: "change", data: TableData[], extra: _arco_design_web_vue.TableChangeExtra, currentData: TableData[]) => void) & ((event: "cellMouseEnter", record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => void) & ((event: "cellMouseLeave", record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => void) & ((event: "cellClick", record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => void) & ((event: "rowClick", record: TableData, ev: Event) => void) & ((event: "headerClick", column: _arco_design_web_vue.TableColumnData, ev: Event) => void) & ((event: "columnResize", dataIndex: string, width: number) => void) & ((event: "rowDblclick", record: TableData, ev: Event) => void) & ((event: "cellDblclick", record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => void) & ((event: "rowContextmenu", record: TableData, ev: Event) => void) & ((event: "cellContextmenu", record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => void);
        $el: any;
        $options: vue.ComponentOptionsBase<Readonly<{
            columns?: unknown;
            data?: unknown;
            bordered?: unknown;
            hoverable?: unknown;
            stripe?: unknown;
            size?: unknown;
            tableLayoutFixed?: unknown;
            loading?: unknown;
            rowSelection?: unknown;
            expandable?: unknown;
            scroll?: unknown;
            pagination?: unknown;
            pagePosition?: unknown;
            indentSize?: unknown;
            rowKey?: unknown;
            showHeader?: unknown;
            virtualListProps?: unknown;
            spanMethod?: unknown;
            spanAll?: unknown;
            components?: unknown;
            loadMore?: unknown;
            filterIconAlignLeft?: unknown;
            hideExpandButtonOnEmpty?: unknown;
            rowClass?: unknown;
            draggable?: unknown;
            rowNumber?: unknown;
            columnResizable?: unknown;
            summary?: unknown;
            summaryText?: unknown;
            summarySpanMethod?: unknown;
            selectedKeys?: unknown;
            defaultSelectedKeys?: unknown;
            expandedKeys?: unknown;
            defaultExpandedKeys?: unknown;
            defaultExpandAllRows?: unknown;
            stickyHeader?: unknown;
            scrollbar?: unknown;
            showEmptyTree?: unknown;
        } & {
            size: "mini" | "medium" | "large" | "small";
            scrollbar: boolean | _arco_design_web_vue.ScrollbarProps;
            data: TableData[];
            loading: boolean | Record<string, any>;
            bordered: boolean | _arco_design_web_vue.TableBorder;
            columns: _arco_design_web_vue.TableColumnData[];
            hoverable: boolean;
            pagination: boolean | PaginationProps;
            stripe: boolean;
            tableLayoutFixed: boolean;
            pagePosition: "top" | "tl" | "tr" | "bottom" | "bl" | "br";
            indentSize: number;
            rowKey: string;
            showHeader: boolean;
            spanAll: boolean;
            filterIconAlignLeft: boolean;
            hideExpandButtonOnEmpty: boolean;
            columnResizable: boolean;
            summaryText: string;
            defaultExpandAllRows: boolean;
            stickyHeader: number | boolean;
            showEmptyTree: boolean;
        } & {
            scroll?: {
                x?: string | number | undefined;
                y?: string | number | undefined;
                minWidth?: string | number | undefined;
                maxHeight?: string | number | undefined;
            } | undefined;
            summary?: boolean | ((params: {
                columns: _arco_design_web_vue.TableColumnData[];
                data: TableData[];
            }) => TableData[]) | undefined;
            components?: _arco_design_web_vue_es_table_interface.TableComponents | undefined;
            virtualListProps?: _arco_design_web_vue_es__components_virtual_list_v2_interface.VirtualListProps | undefined;
            rowSelection?: _arco_design_web_vue.TableRowSelection | undefined;
            expandable?: _arco_design_web_vue.TableExpandable | undefined;
            spanMethod?: ((data: {
                record: TableData;
                column: _arco_design_web_vue.TableColumnData | _arco_design_web_vue_es_table_interface.TableOperationColumn;
                rowIndex: number;
                columnIndex: number;
            }) => void | {
                rowspan?: number | undefined;
                colspan?: number | undefined;
            }) | undefined;
            loadMore?: ((record: TableData, done: (children?: TableData[] | undefined) => void) => void) | undefined;
            rowClass?: string | any[] | Record<string, any> | ((record: TableData, rowIndex: number) => any) | undefined;
            draggable?: _arco_design_web_vue.TableDraggable | undefined;
            rowNumber?: boolean | Record<string, any> | undefined;
            summarySpanMethod?: ((data: {
                record: TableData;
                column: _arco_design_web_vue.TableColumnData | _arco_design_web_vue_es_table_interface.TableOperationColumn;
                rowIndex: number;
                columnIndex: number;
            }) => void | {
                rowspan?: number | undefined;
                colspan?: number | undefined;
            }) | undefined;
            selectedKeys?: (string | number)[] | undefined;
            defaultSelectedKeys?: (string | number)[] | undefined;
            expandedKeys?: (string | number)[] | undefined;
            defaultExpandedKeys?: (string | number)[] | undefined;
        }> & {
            onChange?: ((data: TableData[], extra: _arco_design_web_vue.TableChangeExtra, currentData: TableData[]) => any) | undefined;
            onSelect?: ((rowKeys: (string | number)[], rowKey: string | number, record: TableData) => any) | undefined;
            onPageChange?: ((page: number) => any) | undefined;
            onPageSizeChange?: ((pageSize: number) => any) | undefined;
            onExpand?: ((rowKey: string | number, record: TableData) => any) | undefined;
            "onUpdate:selectedKeys"?: ((rowKeys: (string | number)[]) => any) | undefined;
            "onUpdate:expandedKeys"?: ((rowKeys: (string | number)[]) => any) | undefined;
            onExpandedChange?: ((rowKeys: (string | number)[]) => any) | undefined;
            onSelectAll?: ((checked: boolean) => any) | undefined;
            onSelectionChange?: ((rowKeys: (string | number)[]) => any) | undefined;
            onSorterChange?: ((dataIndex: string, direction: string) => any) | undefined;
            onFilterChange?: ((dataIndex: string, filteredValues: string[]) => any) | undefined;
            onCellMouseEnter?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onCellMouseLeave?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onCellClick?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onRowClick?: ((record: TableData, ev: Event) => any) | undefined;
            onHeaderClick?: ((column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onColumnResize?: ((dataIndex: string, width: number) => any) | undefined;
            onRowDblclick?: ((record: TableData, ev: Event) => any) | undefined;
            onCellDblclick?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
            onRowContextmenu?: ((record: TableData, ev: Event) => any) | undefined;
            onCellContextmenu?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        }, {
            render: () => JSX.Element;
            selfExpand: (rowKey: _arco_design_web_vue_es__utils_types.BaseType | _arco_design_web_vue_es__utils_types.BaseType[], expanded?: boolean | undefined) => void;
            selfExpandAll: (expanded?: boolean | undefined) => void;
            selfSelect: (rowKey: _arco_design_web_vue_es__utils_types.BaseType | _arco_design_web_vue_es__utils_types.BaseType[], checked?: boolean | undefined) => void;
            selfSelectAll: (checked?: boolean | undefined) => void;
            selfResetFilters: (dataIndex?: string | string[] | undefined) => void;
            selfClearFilters: (dataIndex?: string | string[] | undefined) => void;
            selfResetSorters: () => void;
            selfClearSorters: () => void;
        }, unknown, {}, {
            selectAll(checked?: boolean | undefined): void;
            select(rowKey: string | number | (string | number)[], checked?: boolean | undefined): void;
            expandAll(checked?: boolean | undefined): void;
            expand(rowKey: string | number | (string | number)[], checked?: boolean | undefined): void;
            resetFilters(dataIndex?: string | string[] | undefined): void;
            clearFilters(dataIndex?: string | string[] | undefined): void;
            resetSorters(): void;
            clearSorters(): void;
        }, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {
            'update:selectedKeys': (rowKeys: (string | number)[]) => true;
            'update:expandedKeys': (rowKeys: (string | number)[]) => true;
            expand: (rowKey: string | number, record: TableData) => true;
            expandedChange: (rowKeys: (string | number)[]) => true;
            select: (rowKeys: (string | number)[], rowKey: string | number, record: TableData) => true;
            selectAll: (checked: boolean) => true;
            selectionChange: (rowKeys: (string | number)[]) => true;
            sorterChange: (dataIndex: string, direction: string) => true;
            filterChange: (dataIndex: string, filteredValues: string[]) => true;
            pageChange: (page: number) => true;
            pageSizeChange: (pageSize: number) => true;
            change: (data: TableData[], extra: _arco_design_web_vue.TableChangeExtra, currentData: TableData[]) => true;
            cellMouseEnter: (record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => true;
            cellMouseLeave: (record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => true;
            cellClick: (record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => true;
            rowClick: (record: TableData, ev: Event) => true;
            headerClick: (column: _arco_design_web_vue.TableColumnData, ev: Event) => true;
            columnResize: (dataIndex: string, width: number) => true;
            rowDblclick: (record: TableData, ev: Event) => true;
            cellDblclick: (record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => true;
            rowContextmenu: (record: TableData, ev: Event) => true;
            cellContextmenu: (record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => true;
        }, string, {
            size: "mini" | "medium" | "large" | "small";
            scrollbar: boolean | _arco_design_web_vue.ScrollbarProps;
            data: TableData[];
            loading: boolean | Record<string, any>;
            bordered: boolean | _arco_design_web_vue.TableBorder;
            columns: _arco_design_web_vue.TableColumnData[];
            hoverable: boolean;
            pagination: boolean | PaginationProps;
            stripe: boolean;
            tableLayoutFixed: boolean;
            pagePosition: "top" | "tl" | "tr" | "bottom" | "bl" | "br";
            indentSize: number;
            rowKey: string;
            showHeader: boolean;
            spanAll: boolean;
            filterIconAlignLeft: boolean;
            hideExpandButtonOnEmpty: boolean;
            columnResizable: boolean;
            summaryText: string;
            defaultExpandAllRows: boolean;
            stickyHeader: number | boolean;
            showEmptyTree: boolean;
        }, {}, string, {}> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: vue.DebuggerEvent) => void) | ((e: vue.DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: vue.DebuggerEvent) => void) | ((e: vue.DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof vue.nextTick;
        $watch<T_1 extends string | ((...args: any) => any)>(source: T_1, cb: T_1 extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: vue.WatchOptions<boolean> | undefined): vue.WatchStopHandle;
    } & Readonly<{
        columns?: unknown;
        data?: unknown;
        bordered?: unknown;
        hoverable?: unknown;
        stripe?: unknown;
        size?: unknown;
        tableLayoutFixed?: unknown;
        loading?: unknown;
        rowSelection?: unknown;
        expandable?: unknown;
        scroll?: unknown;
        pagination?: unknown;
        pagePosition?: unknown;
        indentSize?: unknown;
        rowKey?: unknown;
        showHeader?: unknown;
        virtualListProps?: unknown;
        spanMethod?: unknown;
        spanAll?: unknown;
        components?: unknown;
        loadMore?: unknown;
        filterIconAlignLeft?: unknown;
        hideExpandButtonOnEmpty?: unknown;
        rowClass?: unknown;
        draggable?: unknown;
        rowNumber?: unknown;
        columnResizable?: unknown;
        summary?: unknown;
        summaryText?: unknown;
        summarySpanMethod?: unknown;
        selectedKeys?: unknown;
        defaultSelectedKeys?: unknown;
        expandedKeys?: unknown;
        defaultExpandedKeys?: unknown;
        defaultExpandAllRows?: unknown;
        stickyHeader?: unknown;
        scrollbar?: unknown;
        showEmptyTree?: unknown;
    } & {
        size: "mini" | "medium" | "large" | "small";
        scrollbar: boolean | _arco_design_web_vue.ScrollbarProps;
        data: TableData[];
        loading: boolean | Record<string, any>;
        bordered: boolean | _arco_design_web_vue.TableBorder;
        columns: _arco_design_web_vue.TableColumnData[];
        hoverable: boolean;
        pagination: boolean | PaginationProps;
        stripe: boolean;
        tableLayoutFixed: boolean;
        pagePosition: "top" | "tl" | "tr" | "bottom" | "bl" | "br";
        indentSize: number;
        rowKey: string;
        showHeader: boolean;
        spanAll: boolean;
        filterIconAlignLeft: boolean;
        hideExpandButtonOnEmpty: boolean;
        columnResizable: boolean;
        summaryText: string;
        defaultExpandAllRows: boolean;
        stickyHeader: number | boolean;
        showEmptyTree: boolean;
    } & {
        scroll?: {
            x?: string | number | undefined;
            y?: string | number | undefined;
            minWidth?: string | number | undefined;
            maxHeight?: string | number | undefined;
        } | undefined;
        summary?: boolean | ((params: {
            columns: _arco_design_web_vue.TableColumnData[];
            data: TableData[];
        }) => TableData[]) | undefined;
        components?: _arco_design_web_vue_es_table_interface.TableComponents | undefined;
        virtualListProps?: _arco_design_web_vue_es__components_virtual_list_v2_interface.VirtualListProps | undefined;
        rowSelection?: _arco_design_web_vue.TableRowSelection | undefined;
        expandable?: _arco_design_web_vue.TableExpandable | undefined;
        spanMethod?: ((data: {
            record: TableData;
            column: _arco_design_web_vue.TableColumnData | _arco_design_web_vue_es_table_interface.TableOperationColumn;
            rowIndex: number;
            columnIndex: number;
        }) => void | {
            rowspan?: number | undefined;
            colspan?: number | undefined;
        }) | undefined;
        loadMore?: ((record: TableData, done: (children?: TableData[] | undefined) => void) => void) | undefined;
        rowClass?: string | any[] | Record<string, any> | ((record: TableData, rowIndex: number) => any) | undefined;
        draggable?: _arco_design_web_vue.TableDraggable | undefined;
        rowNumber?: boolean | Record<string, any> | undefined;
        summarySpanMethod?: ((data: {
            record: TableData;
            column: _arco_design_web_vue.TableColumnData | _arco_design_web_vue_es_table_interface.TableOperationColumn;
            rowIndex: number;
            columnIndex: number;
        }) => void | {
            rowspan?: number | undefined;
            colspan?: number | undefined;
        }) | undefined;
        selectedKeys?: (string | number)[] | undefined;
        defaultSelectedKeys?: (string | number)[] | undefined;
        expandedKeys?: (string | number)[] | undefined;
        defaultExpandedKeys?: (string | number)[] | undefined;
    }> & {
        onChange?: ((data: TableData[], extra: _arco_design_web_vue.TableChangeExtra, currentData: TableData[]) => any) | undefined;
        onSelect?: ((rowKeys: (string | number)[], rowKey: string | number, record: TableData) => any) | undefined;
        onPageChange?: ((page: number) => any) | undefined;
        onPageSizeChange?: ((pageSize: number) => any) | undefined;
        onExpand?: ((rowKey: string | number, record: TableData) => any) | undefined;
        "onUpdate:selectedKeys"?: ((rowKeys: (string | number)[]) => any) | undefined;
        "onUpdate:expandedKeys"?: ((rowKeys: (string | number)[]) => any) | undefined;
        onExpandedChange?: ((rowKeys: (string | number)[]) => any) | undefined;
        onSelectAll?: ((checked: boolean) => any) | undefined;
        onSelectionChange?: ((rowKeys: (string | number)[]) => any) | undefined;
        onSorterChange?: ((dataIndex: string, direction: string) => any) | undefined;
        onFilterChange?: ((dataIndex: string, filteredValues: string[]) => any) | undefined;
        onCellMouseEnter?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        onCellMouseLeave?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        onCellClick?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        onRowClick?: ((record: TableData, ev: Event) => any) | undefined;
        onHeaderClick?: ((column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        onColumnResize?: ((dataIndex: string, width: number) => any) | undefined;
        onRowDblclick?: ((record: TableData, ev: Event) => any) | undefined;
        onCellDblclick?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
        onRowContextmenu?: ((record: TableData, ev: Event) => any) | undefined;
        onCellContextmenu?: ((record: TableData, column: _arco_design_web_vue.TableColumnData, ev: Event) => any) | undefined;
    } & vue.ShallowUnwrapRef<{
        render: () => JSX.Element;
        selfExpand: (rowKey: _arco_design_web_vue_es__utils_types.BaseType | _arco_design_web_vue_es__utils_types.BaseType[], expanded?: boolean | undefined) => void;
        selfExpandAll: (expanded?: boolean | undefined) => void;
        selfSelect: (rowKey: _arco_design_web_vue_es__utils_types.BaseType | _arco_design_web_vue_es__utils_types.BaseType[], checked?: boolean | undefined) => void;
        selfSelectAll: (checked?: boolean | undefined) => void;
        selfResetFilters: (dataIndex?: string | string[] | undefined) => void;
        selfClearFilters: (dataIndex?: string | string[] | undefined) => void;
        selfResetSorters: () => void;
        selfClearSorters: () => void;
    }> & {} & {
        selectAll(checked?: boolean | undefined): void;
        select(rowKey: string | number | (string | number)[], checked?: boolean | undefined): void;
        expandAll(checked?: boolean | undefined): void;
        expand(rowKey: string | number | (string | number)[], checked?: boolean | undefined): void;
        resetFilters(dataIndex?: string | string[] | undefined): void;
        clearFilters(dataIndex?: string | string[] | undefined): void;
        resetSorters(): void;
        clearSorters(): void;
    } & vue.ComponentCustomProperties & {}) | null>;
    originColumns: Ref<TableColumnDataPlus[]>;
    columns: Ref<TableColumnDataPlus[]>;
    columnKeys: Ref<string[]>;
    resetColumns: () => void;
    changeColumnVisibleByDataIndex: (dataIndex: string, visible: boolean) => void;
    updateColumnByDataIndex: <K extends keyof TableColumnDataPlus>(dataIndex: string, field: K, value: TableColumnDataPlus[K]) => void;
    replaceColumnByDataIndex: (dataIndex: string, column: TableColumnDataPlus) => void;
    tableConfig: {
        loading: boolean;
        data: T[];
        columns: TableColumnDataPlus[];
        ref: (el: any) => void;
        pagination: false | PaginationPropsPlus;
        onPageChange: ((current: number) => void) | undefined;
        onPageSizeChange: ((pageSize: number) => void) | undefined;
        onColumnResize: (dataIndex: string, width: number) => void;
    };
};

export { type TableConfig, useTable };
